;CodeVisionAVR C Compiler V1.24.4 Standard
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type           : ATmega64
;Program type        : Application
;Clock frequency     : 11.059200 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : int, width
;External SRAM size  : 0
;Data Stack size     : 1024 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "32kSRAM.vec"
	.INCLUDE "32kSRAM.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500
;       1 /******************************************
;       2 Program : 32kSRAM Example for Micro64
;       3 Company : Micromint, Inc.
;       4 *********************************************/
;       5      
;       6 #include <mega64.h>
;       7 #include <MMRS485.h>                   // Micromints Library for using both USARTs
;       8 #include <stdio.h>                     // Standard I/O library    
;       9 #include <delay.h>  
;      10 // Macros to use in order to set individual bits in extended I/O space located in SRAM between 
;      11 // 0x60 and 0xFF can not use the CBI or SBI assembly instruction to clear or set a bit.    
;      12 #define SETBIT(port,bit)(port)|=1<<(bit)
;      13 #define CLRBIT(port,bit)(port)&=~(1<<(bit))
;      14 #define OFFSET 0x2000
;      15 // Declare your global variables here
;      16 int COM;                               // if COM = 0 then use USART0 if it = 1 then use USART1     
;      17 int CH0 @0x7ffe;
	.ORG 0x7FFE
_CH0:
	.BYTE 0x2
	.ORG 0x500
;      18 
;      19 unsigned int Data @0xFFE;              // This the memory location where the 12-bit ADC conversion 
	.ORG 0xFFE
_Data:
	.BYTE 0x2
	.ORG 0x500
;      20                                        //count is stored after calling the utility to read a channel
;      21 
;      22 // Routines used to call the utilities for the 12-bit ADC
;      23 void(*SingleADC1)(void)=0x7BFD;  
_SingleADC1:
	.BYTE 0x2
;      24 void(*SingleADC0)(void)=0x7C04;  
_SingleADC0:
	.BYTE 0x2
;      25 void RD_RAM(unsigned int);
;      26 void WR_RAM(unsigned int);
;      27 void WRRAM_0000h(unsigned int, unsigned char);
;      28 void RDRAM_0000h(unsigned int);
;      29 void main(void)
;      30 {

	.CSEG
_main:
;      31 // Declare your local variables here
;      32 
;      33 // External SRAM page configuration: 
;      34 //              -              / 0000h - 7FFFh
;      35 // Lower page wait state(s): None
;      36 // Upper page wait state(s): None
;      37 MCUCR=0x80;
	LDI  R30,LOW(128)
	OUT  0x35,R30
;      38 XMCRA=0x00;    
	LDI  R30,LOW(0)
	STS  0x6D,R30
;      39 CLRBIT(XMCRB,0);  //Make XMM0 bit 0 of the XMCRB register low enabling all of external SRAM
	CALL SUBOPT_0x0
;      40 CLRBIT(XMCRB,1);  //Make XMM0 bit 1 of the XMCRB register low
;      41 CLRBIT(XMCRB,2);  //Make XMM0 bit 2 of the XMCRB register low
	LDS  R30,108
	ANDI R30,0xFB
	STS  108,R30
;      42 
;      43 // Set up USART1's Baud rate at 9600 bps with a 11.0592 MHz Crystal
;      44 UCSR1A=0x00;      // RX EN, TX EN
	LDI  R30,LOW(0)
	STS  0x9B,R30
;      45 UCSR1B=0x18;     // RX EN, TX EN
	LDI  R30,LOW(24)
	STS  0x9A,R30
;      46 UCSR1C=0x06;     // 8N1
	LDI  R30,LOW(6)
	STS  0x9D,R30
;      47 UBRR1H=0x00;    // Baud rate high - 9600
	LDI  R30,LOW(0)
	STS  0x98,R30
;      48 UBRR1L=0x47;   // Baud rate low 
	LDI  R30,LOW(71)
	STS  0x99,R30
;      49 
;      50 COM = 1;                           // Use USART1  
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 4,5
;      51 DDRD.6 = 0;			   // Make PORTD.6 an output  
	CBI  0x11,6
;      52 PORTD.6 = 1; 			   // Enable the RS485 control line  
	SBI  0x12,6
;      53 
;      54 while (1)
_0x5:
;      55       {     
;      56       (*SingleADC0)();
	__CALL1MN _SingleADC0,0
;      57       CH0 = Data;
	LDS  R30,_Data
	LDS  R31,_Data+1
	STS  _CH0,R30
	STS  _CH0+1,R31
;      58       printf("CH0 = %d\r\n",CH0); 
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_CH0
	LDS  R31,_CH0+1
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;      59       printf("\r\n");
	__POINTW1FN _0,8
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      60       WR_RAM(0x2000);
	LDI  R30,LOW(8192)
	LDI  R31,HIGH(8192)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _WR_RAM
;      61       WRRAM_0000h(0x0000, 39);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(39)
	ST   -Y,R30
	RCALL _WRRAM_0000h
;      62       WRRAM_0000h(0x0001, 40);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL _WRRAM_0000h
;      63       WRRAM_0000h(0x0002, 41);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	RCALL _WRRAM_0000h
;      64       RDRAM_0000h(0x0000);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _RDRAM_0000h
;      65       RDRAM_0000h(0x0001);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _RDRAM_0000h
;      66       RDRAM_0000h(0x0002);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _RDRAM_0000h
;      67       RD_RAM(0x2000); 
	LDI  R30,LOW(8192)
	LDI  R31,HIGH(8192)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _RD_RAM
;      68       delay_ms(3000); 
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;      69       };
	RJMP _0x5
;      70 }                       
_0x8:
	RJMP _0x8
;      71 
;      72 void WR_RAM(unsigned int MemAddr)
;      73 {
_WR_RAM:
;      74    int *p;
;      75    p=MemAddr;    
	ST   -Y,R17
	ST   -Y,R16
;	MemAddr -> Y+2
;	*p -> R16,R17
	__GETWRS 16,17,2
;      76    while(p < (MemAddr + 10))
_0x9:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,10
	CP   R16,R30
	CPC  R17,R31
	BRSH _0xB
;      77    {     
;      78      (*SingleADC1)();
	__CALL1MN _SingleADC1,0
;      79      *p = Data;  
	LDS  R30,_Data
	LDS  R31,_Data+1
	__GETW2R 16,17
	ST   X+,R30
	ST   X,R31
;      80      printf("Wrote %d", Data);
	__POINTW1FN _0,11
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Data
	LDS  R31,_Data+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;      81      printf(" to location %X", p);
	__POINTW1FN _0,20
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 16,17
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;      82      printf("    \r\n");         
	__POINTW1FN _0,36
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      83      p++;
	__ADDWRN 16,17,2
;      84    } 
	RJMP _0x9
_0xB:
;      85    printf("\r\n");
	__POINTW1FN _0,8
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      86 }                 
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	RET
;      87    
;      88 void RD_RAM(unsigned int MemAddr)
;      89 {
_RD_RAM:
;      90    int CH1;
;      91    int *p;
;      92    p=MemAddr;
	CALL __SAVELOCR4
;	MemAddr -> Y+4
;	CH1 -> R16,R17
;	*p -> R18,R19
	__GETWRS 18,19,4
;      93    while(p < (MemAddr + 10))
_0xC:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,10
	CP   R18,R30
	CPC  R19,R31
	BRSH _0xE
;      94    {               
;      95      CH1=*p; 
	__GETW2R 18,19
	LD   R16,X+
	LD   R17,X
;      96      printf("Read %d", CH1);
	__POINTW1FN _0,43
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 16,17
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;      97      printf(" at location %X", p);
	__POINTW1FN _0,51
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 18,19
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;      98      printf("    \r\n");    
	__POINTW1FN _0,36
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;      99      p++;
	__ADDWRN 18,19,2
;     100    }       
	RJMP _0xC
_0xE:
;     101    printf("\r\n");
	__POINTW1FN _0,8
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     102 }
	CALL __LOADLOCR4
	ADIW R28,6
	RET
;     103 
;     104 void WRRAM_0000h(unsigned int MemAddr, unsigned char WRData)
;     105 {
_WRRAM_0000h:
;     106    unsigned char *p = (unsigned char *) (OFFSET + 1);   // This assignment is called casting.
;     107    p = OFFSET + MemAddr;  
	ST   -Y,R17
	ST   -Y,R16
;	MemAddr -> Y+3
;	WRData -> Y+2
;	*p -> R16,R17
	LDI  R16,LOW(0x2001)
	LDI  R17,HIGH(0x2001)
	CALL SUBOPT_0x1
;     108    
;     109    DDRC = 0xFF;   // Set the released port pin PORTC.7, PORTC.6, and PORTC.5 to outputs
;     110    PORTC = 0x00;  // Make the outputs low
;     111    // Settng the following two bits releases some of PORTC from the External Memory Access
;     112    SETBIT(XMCRB,0);  //Make XMM0 bit 0 and bit 1 of the XMCRB register high to make external
;     113    SETBIT(XMCRB,1);  //SRAM enabled up to address 1FFFH. 
;     114    *p = WRData; 
	LDD  R30,Y+2
	__GETW2R 16,17
	ST   X,R30
;     115     printf("Wrote %d", WRData);
	__POINTW1FN _0,11
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     116     printf(" to location %X", p-OFFSET);
	__POINTW1FN _0,20
	CALL SUBOPT_0x2
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     117     printf("    \r\n");         
	__POINTW1FN _0,36
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     118     printf("\r\n"); 
	__POINTW1FN _0,8
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     119    // Clear the following two bits to make all of PORTC used for External Memory Access
;     120    CLRBIT(XMCRB,0);  //Make XMM0 bit 0 of the XMCRB register low enabling all of external SRAM
;     121    CLRBIT(XMCRB,1);  //Make XMM0 bit 1 of the XMCRB register low
;     122 }                 
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
;     123    
;     124 void RDRAM_0000h(unsigned int MemAddr)
;     125 {
_RDRAM_0000h:
;     126   unsigned char *p = (unsigned char *) (OFFSET + 1);   // This assignment is called casting.
;     127   unsigned char RDData;   
;     128     p = OFFSET + MemAddr; 
	CALL __SAVELOCR3
;	MemAddr -> Y+3
;	*p -> R16,R17
;	RDData -> R18
	LDI  R16,LOW(0x2001)
	LDI  R17,HIGH(0x2001)
	CALL SUBOPT_0x1
;     129     DDRC = 0xFF;   // Set the released port pin PORTC.7, PORTC.6, and PORTC.5 to outputs
;     130     PORTC = 0x00;  // Make the outputs low
;     131     // Settng the following two bits releases some of PORTC from the External Memory Access
;     132     SETBIT(XMCRB,0);  //Make XMM0 bit 0 and bit 1 of the XMCRB register high to make external
;     133     SETBIT(XMCRB,1);  //SRAM enabled up to address 1FFFH. 
;     134     RDData = *p; 
	__GETW2R 16,17
	LD   R18,X
;     135     printf("Read %d", RDData);
	__POINTW1FN _0,43
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R18
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     136     printf(" to location %X", p-OFFSET);
	__POINTW1FN _0,20
	CALL SUBOPT_0x2
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     137     printf("    \r\n");         
	__POINTW1FN _0,36
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     138     printf("\r\n"); 
	__POINTW1FN _0,8
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     139    // Clear the following two bits to make all of PORTC used for External Memory Access
;     140     CLRBIT(XMCRB,0);  //Make XMM0 bit 0 of the XMCRB register low enabling all of external SRAM
;     141     CLRBIT(XMCRB,1);  //Make XMM0 bit 1 of the XMCRB register low
;     142 }
	CALL __LOADLOCR3
	ADIW R28,5
	RET

_putchar:
	__GETW1R 4,5
	SBIW R30,0
	BRNE _0x26
_0x27:
	SBIS 0xB,5
	RJMP _0x27
	LD   R30,Y
	OUT  0xC,R30
	RJMP _0x25
_0x26:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x25
_0x2B:
	LDS  R30,155
	ANDI R30,LOW(0x20)
	BREQ _0x2B
	LD   R30,Y
	STS  0x9C,R30
_0x2E:
	LDS  R30,155
	ANDI R30,LOW(0x40)
	BREQ _0x2E
_0x25:
	ADIW R28,1
	RET
__put_G3:
	put:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x31
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	SBIW R30,1
	LDD  R26,Y+2
	STD  Z+0,R26
	RJMP _0x32
_0x31:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
_0x32:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R16,0
_0x33:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x35
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x39
	CPI  R19,37
	BRNE _0x3A
	LDI  R16,LOW(1)
	RJMP _0x3B
_0x3A:
	CALL SUBOPT_0x4
_0x3B:
	RJMP _0x38
_0x39:
	CPI  R30,LOW(0x1)
	BRNE _0x3C
	CPI  R19,37
	BRNE _0x3D
	CALL SUBOPT_0x4
	LDI  R16,LOW(0)
	RJMP _0x38
_0x3D:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x3E
	LDI  R17,LOW(1)
	RJMP _0x38
_0x3E:
	CPI  R19,43
	BRNE _0x3F
	LDI  R21,LOW(43)
	RJMP _0x38
_0x3F:
	CPI  R19,32
	BRNE _0x40
	LDI  R21,LOW(32)
	RJMP _0x38
_0x40:
	RJMP _0x41
_0x3C:
	CPI  R30,LOW(0x2)
	BRNE _0x42
_0x41:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x43
	ORI  R17,LOW(128)
	RJMP _0x38
_0x43:
	RJMP _0x44
_0x42:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x38
_0x44:
	CPI  R19,48
	BRLO _0x47
	CPI  R19,58
	BRLO _0x48
_0x47:
	RJMP _0x46
_0x48:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x38
_0x46:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x4C
	CALL SUBOPT_0x5
	LD   R30,X
	CALL SUBOPT_0x6
	RJMP _0x4D
_0x4C:
	CPI  R30,LOW(0x73)
	BRNE _0x4F
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	CALL _strlen
	MOV  R16,R30
	RJMP _0x50
_0x4F:
	CPI  R30,LOW(0x70)
	BRNE _0x52
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	CALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x50:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x53
_0x52:
	CPI  R30,LOW(0x64)
	BREQ _0x56
	CPI  R30,LOW(0x69)
	BRNE _0x57
_0x56:
	ORI  R17,LOW(4)
	RJMP _0x58
_0x57:
	CPI  R30,LOW(0x75)
	BRNE _0x59
_0x58:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x5A
_0x59:
	CPI  R30,LOW(0x58)
	BRNE _0x5C
	ORI  R17,LOW(8)
	RJMP _0x5D
_0x5C:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x8B
_0x5D:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x5A:
	SBRS R17,2
	RJMP _0x5F
	CALL SUBOPT_0x5
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x60
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x60:
	CPI  R21,0
	BREQ _0x61
	SUBI R16,-LOW(1)
	RJMP _0x62
_0x61:
	ANDI R17,LOW(251)
_0x62:
	RJMP _0x63
_0x5F:
	CALL SUBOPT_0x5
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x63:
_0x53:
	SBRC R17,0
	RJMP _0x64
_0x65:
	CP   R16,R20
	BRSH _0x67
	SBRS R17,7
	RJMP _0x68
	SBRS R17,2
	RJMP _0x69
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x6A
_0x69:
	LDI  R19,LOW(48)
_0x6A:
	RJMP _0x6B
_0x68:
	LDI  R19,LOW(32)
_0x6B:
	CALL SUBOPT_0x4
	SUBI R20,LOW(1)
	RJMP _0x65
_0x67:
_0x64:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x6C
_0x6D:
	CPI  R18,0
	BREQ _0x6F
	SBRS R17,3
	RJMP _0x70
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x8C
_0x70:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x8C:
	ST   -Y,R30
	CALL SUBOPT_0x8
	CPI  R20,0
	BREQ _0x72
	SUBI R20,LOW(1)
_0x72:
	SUBI R18,LOW(1)
	RJMP _0x6D
_0x6F:
	RJMP _0x73
_0x6C:
_0x75:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x77
	SBRS R17,3
	RJMP _0x78
	SUBI R19,-LOW(7)
	RJMP _0x79
_0x78:
	SUBI R19,-LOW(39)
_0x79:
_0x77:
	SBRC R17,4
	RJMP _0x7B
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x7D
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x7C
_0x7D:
	ORI  R17,LOW(16)
	RJMP _0x7F
_0x7C:
	CP   R20,R18
	BRLO _0x81
	SBRS R17,0
	RJMP _0x82
_0x81:
	RJMP _0x80
_0x82:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x83
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x7F:
	SBRS R17,2
	RJMP _0x84
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x8
	CPI  R20,0
	BREQ _0x85
	SUBI R20,LOW(1)
_0x85:
_0x84:
_0x83:
_0x7B:
	RCALL SUBOPT_0x4
	CPI  R20,0
	BREQ _0x86
	SUBI R20,LOW(1)
_0x86:
_0x80:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x76
	RJMP _0x75
_0x76:
_0x73:
	SBRS R17,0
	RJMP _0x87
_0x88:
	CPI  R20,0
	BREQ _0x8A
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x6
	RJMP _0x88
_0x8A:
_0x87:
_0x8B:
_0x4D:
	LDI  R16,LOW(0)
_0x38:
	RJMP _0x33
_0x35:
	CALL __LOADLOCR6
	ADIW R28,18
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	__PUTW2R 16,17
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G3
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	LDS  R30,108
	ANDI R30,0xFE
	STS  108,R30
	LDS  R30,108
	ANDI R30,0xFD
	STS  108,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	SUBI R30,LOW(-8192)
	SBCI R31,HIGH(-8192)
	__PUTW1R 16,17
	LDI  R30,LOW(255)
	OUT  0x14,R30
	LDI  R30,LOW(0)
	OUT  0x15,R30
	LDS  R30,108
	ORI  R30,1
	STS  108,R30
	LDS  R30,108
	ORI  R30,2
	STS  108,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 16,17
	SUBI R30,LOW(8192)
	SBCI R31,HIGH(8192)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	RCALL _printf
	ADIW R28,2
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xACD
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
